/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
/**
 * Transaction messages if included in the response
 * @export
 * @interface TransactionMessage
 */
export interface TransactionMessage {
  /**
   * Unique identifier for this message
   * @type {string}
   * @memberof TransactionMessage
   */
  id: string;
  /**
   * Unique identifier for the transaction this message belongs to
   * @type {string}
   * @memberof TransactionMessage
   */
  transactionId: string;
  /**
   * Sender BIC/SWIFT number
   * @type {string}
   * @memberof TransactionMessage
   */
  senderBic: string;
  /**
   * Recipient BIC/SWIFT number
   * @type {string}
   * @memberof TransactionMessage
   */
  recipientBic: string;
  /**
   * Counterparty BIC/SWIFT number
   * @type {string}
   * @memberof TransactionMessage
   */
  counterPartyBic: string;
  /**
   * Transaction amount
   * @type {number}
   * @memberof TransactionMessage
   */
  amount: number;
  /**
   * Transaction currency
   * @type {string}
   * @memberof TransactionMessage
   */
  currency: string;
  /**
   * Message direction
   * @type {string}
   * @memberof TransactionMessage
   */
  direction: TransactionMessageDirectionEnum;
  /**
   * Transaction status
   * @type {string}
   * @memberof TransactionMessage
   */
  type: TransactionMessageTypeEnum;
  /**
   * Additional free-text info about this TX message
   * @type {string}
   * @memberof TransactionMessage
   */
  referenceInfo?: string;
  /**
   * Message date in ISO-8601 zoned date-time
   * @type {Date}
   * @memberof TransactionMessage
   */
  messageDate: Date;
  /**
   * Network used to carry the message
   * @type {string}
   * @memberof TransactionMessage
   */
  network: string;
  /**
   * Rollup transaction hash containing corresponding to this transaction
   * @type {string}
   * @memberof TransactionMessage
   */
  rollupTransactionHash?: string;
}

/**
 * @export
 */
export const TransactionMessageDirectionEnum = {
  Inbox: 'INBOX',
  Outbox: 'OUTBOX',
} as const;
export type TransactionMessageDirectionEnum =
  typeof TransactionMessageDirectionEnum[keyof typeof TransactionMessageDirectionEnum];

/**
 * @export
 */
export const TransactionMessageTypeEnum = {
  _002: '002',
  _004: '004',
  _007: '007',
  _009: '009',
} as const;
export type TransactionMessageTypeEnum =
  typeof TransactionMessageTypeEnum[keyof typeof TransactionMessageTypeEnum];

export function TransactionMessageFromJSON(json: any): TransactionMessage {
  return TransactionMessageFromJSONTyped(json, false);
}

export function TransactionMessageFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransactionMessage {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    id: json['id'],
    transactionId: json['transactionId'],
    senderBic: json['senderBic'],
    recipientBic: json['recipientBic'],
    counterPartyBic: json['counterPartyBic'],
    amount: json['amount'],
    currency: json['currency'],
    direction: json['direction'],
    type: json['type'],
    referenceInfo: !exists(json, 'referenceInfo')
      ? undefined
      : json['referenceInfo'],
    messageDate: new Date(json['messageDate']),
    network: json['network'],
    rollupTransactionHash: !exists(json, 'rollupTransactionHash')
      ? undefined
      : json['rollupTransactionHash'],
  };
}

export function TransactionMessageToJSON(
  value?: TransactionMessage | null
): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    id: value.id,
    transactionId: value.transactionId,
    senderBic: value.senderBic,
    recipientBic: value.recipientBic,
    counterPartyBic: value.counterPartyBic,
    amount: value.amount,
    currency: value.currency,
    direction: value.direction,
    type: value.type,
    referenceInfo: value.referenceInfo,
    messageDate: value.messageDate.toISOString(),
    network: value.network,
    rollupTransactionHash: value.rollupTransactionHash,
  };
}
